## DhBookManager DhBookManager — Aggregation of all DhBook's |

## Functions

DhBookManager * | dh_book_manager_new ()
DhBookManager * | dh_book_manager_get_singleton ()
void | dh_book_manager_populate ()
GList * | dh_book_manager_get_books ()
gboolean | dh_book_manager_get_group_by_language ()
void | dh_book_manager_set_group_by_language ()

## Properties

gboolean | group-by-language | Read / Write

## Signals

void | book-created | Run Last
void | book-deleted | Run Last
void | book-disabled | Run Last
void | book-enabled | Run Last
void | language-disabled | Run Last
void | language-enabled | Run Last

## Types and Values

struct | DhBookManager

## Object Hierarchy

        GObject
        ╰── DhBookManager

## Includes

    #include <devhelp/devhelp.h>

## Description

DhBookManager is a singleton class containing all the DhBook's.

## Functions

### dh_book_manager_new ()

    DhBookManager *
    dh_book_manager_new (void);

`dh_book_manager_new` has been deprecated since version 3.26 and should not be used in newly-written code.

Call `dh_book_manager_get_singleton()` instead.

#### Returns

the DhBookManager singleton instance. You need to unref it when no longer needed.

[transfer full]

### dh_book_manager_get_singleton ()

    DhBookManager *
    dh_book_manager_get_singleton (void);

#### Returns

the DhBookManager singleton instance.

[transfer none]

Since: 3.26

### dh_book_manager_populate ()

    void
    dh_book_manager_populate (DhBookManager *book_manager);

`dh_book_manager_populate` has been deprecated since version 3.26 and should not be used in newly-written code.

The DhBookManager is now automatically populated when the object is created, there is no need to call this function anymore.

Populates the DhBookManager with all books found on the system and user directories.

#### Parameters

book_manager | a DhBookManager. |

### dh_book_manager_get_books ()

    GList *
    dh_book_manager_get_books (DhBookManager *book_manager);

#### Parameters

book_manager | a DhBookManager. |

#### Returns

the list of all DhBook's found.

[element-type DhBook][transfer none]

### dh_book_manager_get_group_by_language ()

    gboolean
    dh_book_manager_get_group_by_language (DhBookManager *book_manager);

#### Parameters

book_manager | a DhBookManager. |

#### Returns

whether the books should be grouped by programming language.

### dh_book_manager_set_group_by_language ()

    void
    dh_book_manager_set_group_by_language (DhBookManager *book_manager,
                                           gboolean group_by_language);

Sets whether the books should be grouped by programming language.

#### Parameters

book_manager | a DhBookManager. |
group_by_language | the new value. |

## Types and Values

### struct DhBookManager

    struct DhBookManager;

## Property Details

### The `“group-by-language”` property

      “group-by-language”        gboolean

Whether books should be grouped by programming language.

Flags: Read / Write

Default value: FALSE

## Signal Details

### The `“book-created”` signal

    void
    user_function (DhBookManager *book_manager,
                   DhBook        *book,
                   gpointer       user_data)

#### Parameters

book_manager | the DhBookManager. |
book | the created DhBook. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“book-deleted”` signal

    void
    user_function (DhBookManager *book_manager,
                   DhBook        *book,
                   gpointer       user_data)

#### Parameters

book_manager | the DhBookManager. |
book | the deleted DhBook. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“book-disabled”` signal

    void
    user_function (DhBookManager *book_manager,
                   DhBook        *book,
                   gpointer       user_data)

#### Parameters

book_manager | the DhBookManager. |
book | the disabled DhBook. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“book-enabled”` signal

    void
    user_function (DhBookManager *book_manager,
                   DhBook        *book,
                   gpointer       user_data)

#### Parameters

book_manager | the DhBookManager. |
book | the enabled DhBook. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“language-disabled”` signal

    void
    user_function (DhBookManager *book_manager,
                   gchar         *language_name,
                   gpointer       user_data)

#### Parameters

book_manager | the DhBookManager. |
language_name | the disabled programming language name. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“language-enabled”` signal

    void
    user_function (DhBookManager *book_manager,
                   gchar         *language_name,
                   gpointer       user_data)

#### Parameters

book_manager | the DhBookManager. |
language_name | the enabled programming language name. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last